//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                                                            IBFX - FOREX STATS INCLUDE.mq4 |
//|                                                                                                                                                     Copyright  2010, Interbank FX, LLC. |
//|                                                                                                                                                                       http://www.ibfx.com |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
#property copyright "Copyright  2010, Interbank FX, LLC."
#property link      "http://www.ibfx.com"
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|      					                                                                            API INSTALL  						                                                             |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
// The API consists of only 2 Files:
//
// IBFX_FOREX_STATS_FUNCTIONS_LIBRARY.ex4
// IBFX_FOREX_STATS_INCLUDE.mqh
//
// Make sure the the files exist in the following locations:
//
// IBFX_FOREX_STATS_FUNCTIONS_LIBRARY.ex4 should be in {MT4 INSTALL PATH}\experts\libraries
// IBFX_FOREX_STATS_INCLUDE.mqh           should be in {MT4 INSTALL PATH}\experts\include
//
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|      					                                                                         LIB FUNCTIONS IMPORT  						                                                       |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
// These functions were created to calculate basic forex statistics and allow any MQL4 programmer to include them in their own code. This can be used inside scripts, Indicators, experts, ... 
// Check the provided sample codes to see different applications of this library. To include the library to your own program plase copy and past the following code at the top of your program
// after the property settings.
//   
// Code:
// -----------------8<--------------------
// #include <IBFX_FOREX_STATS_INCLUDE.mqh>
// ----------------->8--------------------
//   
// To see a full description of each functions Please scroll down to the end of the document.  
//
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
#import "IBFX_FOREX_STATS_FUNCTIONS_LIBRARY.ex4"
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
        
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
        //| IBFX FOREX STATS API FUNCTIONS                                                                                                                                                    |
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
                  void             PipRangeCoreCalc( double& dDataArr[], string sSym , int iPeriods, int iHour, int iDayOfWeek, int iSession, string sSessionStart, string sSessionEnd );
                  void                  AvgPipRange( double& dDataArr[], string sSym , int iPeriods, int iSession, string sSessionStart, string sSessionEnd );
                  void            AvgPipRangeByHour( double& dDataArr[], string sSym , int iPeriods, int iHour );
                  void       AvgPipRangeByDayOfWeek( double& dDataArr[], string sSym , int iPeriods, int iDayOfWeek, int iSession, string sSessionStart, string sSessionEnd );
                  void AvgPipRangeByHourByDayOfWeek( double& dDataArr[], string sSym , int iPeriods, int iHour, int iDayOfWeek );
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
        
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
        //| IBFX OTHER CUSTOM FUNCTIONS                                                                                                                                                       |
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
                     int LoadSymbolArray( string &Syms[] );  
                  string      StrToUpper( string  word );
                  string      StrToLower( string  word );
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+                  
        
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
#import // END OF LIB FUNCTIONS IMPORT                                                                                                                                                        |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|		                                                                         LIB FUNCTIONS DEFINES | CONSTANTS  						                                                       |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
        //| SESSION MODES CODE DEFINES                                                                                                                                                        |
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+        
        // Below we define the 'SESSION' Options for our main function which 
        // will represent the different trading sessions. As well as the session 
        // start and end times. The platform receiving quotes stamped with GMT 
        // based time, the session hours have been adjusted to GMT time but could 
        // be modified by the end user if needed                              
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+        
#define SESSION_ALL     0 // 24 Hours
#define SESSION_USA     1 // USA/NEW YORK SESSION
#define SESSION_EUROPE  2 // EUROPEAN / LONDON SESSION 
#define SESSION_ASIA    3 // ASIAN / TOKYO SESSION
#define SESSION_CUSTOM  4 // ASIAN / TOKYO SESSION
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
        //| SESSION START AND END TIMES DEFINES                                                                                                                                               |
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+        
        // Below we define the 'SESSION' start and end times. Note that the IBFX MT4 platform receivings quotes stamped with GMT based time, the session hours have been adjusted to GMT time 
        // but could be modified by the end user if needed                              
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+  
#define ALL_START "00:00" // GMT 
#define ALL_END   "24:00" // GMT 
#define USA_START "12:00" // GMT 
#define USA_END   "20:00" // GMT 
#define EUR_START "07:00" // GMT 
#define EUR_END   "16:00" // GMT 
#define ASI_START "23:00" // GMT 
#define ASI_END   "08:00" // GMT 
#define CUS_START "11:00" // GMT 
#define CUS_END   "18:00" // GMT 
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
        //| STATS MODES CODE DEFINES                                                                                                                                                          |
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+        
        // Below we define the 'STATS' Options for our main functions which will help define which stat value to return/calculate                        
        //+-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+ 
#define LOW_VALUE  0
#define AVG_VALUE  1
#define HIGH_VALUE 2
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|      					                                                                     CHANGE LOG  					        	                                                             |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//                                                                                                                                                                                            +
// 03/15/2010 - CREATED BY PATRICK NOUVION                                                                                                                                                    +
// 03/16/2010 - UPDATED FUNCTIONS DESCRIPTION                                                                                                                                                 +  
//                                                                                                                                                                                            +
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|      					                                                                    FUNCTIONS DESCRIPTIONS 						                                                          |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+

//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
// PipRangeCoreCalc                                                    						                                                                                                       |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
//         FUNCTION:
// -----------------
//                      void PipRangeCoreCalc ( double& dDataArr[], string sSym , int iPeriods, int iHour, int iDayOfWeek, int iSession, string sSessionStart, string sSessionEnd );
//
//       PARAMETERS:
// -----------------
//
// double& dDataArr[]      //---- RESULT ARRAY                    - DIMENSION SHOULD BE 3 - RESULT[LOW_VALUE] | RESULT[AVG_VALUE] | RESULT[HIGH_VALUE]
//  string sSym            //---- STRING SYMBOL                   - SYMBOL TO USE TO PERFORM THE CALCULATIONS 
//     int iPeriods        //---- INTEGER PERIODS                 - HOW MANY PERIODS TO USE FOR THE CALCULATIONS
//     int iHour           //---- INTEGER HOUR                    - THE HOUR TO USE FOR THE CALCULATIONS | FILTER OPTION - CAN BE ANY VALUE BETWEEN 0 AND 24
//     int iDayOfWeek      //---- INTEGER DAY OF WEEK             - THE DAY OF WEEK TO USE FOR THE CALCULATIONS | FILTER OPTION - CAN BE ANY VALUE BETWEEN 0 - 6
//                                                                         SUNDAY: 0
//                                                                         MONDAY: 1
//                                                                        TUESDAY: 2
//                                                                      WEDNESDAY: 3
//                                                                       THURSDAY: 4
//                                                                         FRIDAY: 5
//                                                                       SATURDAY: 6   
//
//     int iSession        //---- INTEGER SESSION                 - THE SESSION TIMES TO USE FOR THE CALCULATIONS | FILTER OPTION - CAN BE ANY VALUE BETWEEN 0 AND 4
//                                                                  SEE ABOVE "SESSION MODES CODE DEFINES" 
//                     
//  string sSessionStart   //---- STRING SESSION START TIME       - THIS STRING MUST BE IN THE FOLLOWING FORMAT "13:00" - ALSO NOTE THE USE OF 24H BASED TIME
//                                                                  SESSION START AND END TIMES DEFINES  
//
//  string sSessionEnd     //---- STRING SESSION END TIME         - SAME AS ABOVE 
//                                                                  SESSION START AND END TIMES DEFINES
//
//      DESCRIPTION:
// ----------------- 
//   This is in essence the only STATS function in the library, all other functions are in fact just overloaded functions which were created to be easier to use and more descriptive. 
//   This also makes the code easier to update/fix as there is a commom core function for all pip ranges calculations. We recommend using the other functions though this can be used for 
//   debugging purposes.
//   
//   See sample below:
//   -----------------
//   
//   //+------------------------------------------------------------------+
//   //|  OVERLOADED FUNCTION - AVG PIP RANGE BY HOUR BY DOW CALCULATION  |
//   //+------------------------------------------------------------------+
//   void AvgPipRangeByHourByDayOfWeek( 
//                              double&   dDataArr[]
//                             ,string          sSym 
//                             ,   int      iPeriods 
//                            ,   int         iHour
//                             ,   int    iDayOfWeek
//                           //,   int      iSession 
//                           //,string sSessionStart 
//                           //,string    SessionEnd
//   )
//   {
//      //-------
//      PipRangeCoreCalc(                   dDataArr, 
//                                              sSym, 
//                                          iPeriods, 
//                                             iHour, 
//                                        iDayOfWeek, 
//                                                -1, 
//                                                -1,
//                                                -1
//      );
//      //-------
//      return;
//   }
//   //+------------------------------------------------------------------+

//   Notice that we use a void type function and pass an array as a reference. In MQL4 we can not create a function that returns an array and can only fill an array passed by reference
//   hence the use of the void type. However this may not be the best approach outside of MT4.  
//
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+                  

//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//  AvgPipRange                                                      						                                                                                                       |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
//         FUNCTION:
// -----------------
//                      void AvgPipRange ( double& dDataArr[], string sSym , int iPeriods, int iSession, string sSessionStart, string sSessionEnd );
//
//       PARAMETERS:
// -----------------
//
// double& dDataArr[]      //---- RESULT ARRAY                    - DIMENSION SHOULD BE 3 - RESULT[LOW_VALUE] | RESULT[AVG_VALUE] | RESULT[HIGH_VALUE]
//  string sSym            //---- STRING SYMBOL                   - SYMBOL TO USE TO PERFORM THE CALCULATIONS 
//     int iPeriods        //---- INTEGER PERIODS                 - HOW MANY PERIODS TO USE FOR THE CALCULATIONS
//                                                                  IN THIS CALCULATION PERIODS REPRESENTS THE LAST [N] DAYS SO AN INPUT OF 26 WOULD REPRESENT THE LAST 26 DAYS WORTH OF DATA
//                                                                  INCLUDING SUNDAYS          
//
//     int iSession        //---- INTEGER SESSION                 - THE SESSION TIMES TO USE FOR THE CALCULATIONS | FILTER OPTION - CAN BE ANY VALUE BETWEEN 0 AND 4
//                                                                  SEE ABOVE "SESSION MODES CODE DEFINES" 
//                     
//  string sSessionStart   //---- STRING SESSION START TIME       - THIS STRING MUST BE IN THE FOLLOWING FORMAT "13:00" - ALSO NOTE THE USE OF 24H BASED TIME
//                                                                  SESSION START AND END TIMES DEFINES  
//
//  string sSessionEnd     //---- STRING SESSION END TIME         - SAME AS ABOVE 
//                                                                  SESSION START AND END TIMES DEFINES
//
//      DESCRIPTION:
// ----------------- 
//   
// THIS IS A SIMPLE MOVING AVERAGE OF THE DAILY RANGE, WE ALSO STORE THE LOWEST AND HIGHEST VALUES
//   
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+     

//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
// AvgPipRangeByHour                                                  						                                                                                                       |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
//         FUNCTION:
// -----------------
//                      void AvgPipRangeByHour ( double& dDataArr[], string sSym , int iPeriods, int iHour );
//
//       PARAMETERS:
// -----------------
//
// double& dDataArr[]      //---- RESULT ARRAY                    - DIMENSION SHOULD BE 3 - RESULT[LOW_VALUE] | RESULT[AVG_VALUE] | RESULT[HIGH_VALUE]
//  string sSym            //---- STRING SYMBOL                   - SYMBOL TO USE TO PERFORM THE CALCULATIONS   
//     int iPeriods        //---- INTEGER PERIODS                 - HOW MANY PERIODS TO USE FOR THE CALCULATIONS
//                                                                  IN THIS CALCULATION PERIODS REPRESENTS THE LAST [N] DAYS SO AN INPUT OF 26 WOULD REPRESENT THE LAST 26 DAYS WORTH OF DATA
//                                                                  INCLUDING SUNDAYS ONLY USING THE DATA FOR THE HOUR SELECTED IN THE NEXT INPUT.  
//     int iHour           //---- INTEGER HOUR                    - THE HOUR TO USE FOR THE CALCULATIONS | FILTER OPTION - CAN BE ANY VALUE BETWEEN 0 AND 24
//                                                                  IE: IF INPUT = 9 THE RANGE WILL BE THAT OF "09:00" to "09:59"             
//
//      DESCRIPTION:
// ----------------- 
//
// THIS IS A SIMPLE MOVING AVERAGE OF THE HOURLY RANGE, WE ALSO STORE THE LOWEST AND HIGHEST VALUES - NOTE THAT IF THE INPUT IS 15 WE WILL ONLY USE THE RANGE FROM 15:00 TO 15:59 FOR THE LAST 
// 26 DAYS.
//
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+ 

//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
// AvgPipRangeByDayOfWeek                                              						                                                                                                       |
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
//         FUNCTION:
// -----------------
//                      void AvgPipRangeByDayOfWeek ( double& dDataArr[], string sSym , int iPeriods, int iDayOfWeek, int iSession, string sSessionStart, string sSessionEnd );
//
//       PARAMETERS:
// -----------------
//
// double& dDataArr[]      //---- RESULT ARRAY                    - DIMENSION SHOULD BE 3 - RESULT[LOW_VALUE] | RESULT[AVG_VALUE] | RESULT[HIGH_VALUE]
//  string sSym            //---- STRING SYMBOL                   - SYMBOL TO USE TO PERFORM THE CALCULATIONS 
//     int iPeriods        //---- INTEGER PERIODS                 - HOW MANY PERIODS TO USE FOR THE CALCULATIONS
//                                                                  IN THIS CALCULATION PERIODS REPRESENTS THE LAST [N] DAY OF WEEK SO AN INPUT OF 26 WOULD REPRESENT THE LAST 6 MONTHS OR SO 
//                                                                  WORTH OF DATA AS WE WILL IN FACT USE 26 WEEKS OF DATA FOR THE CALCULATIONS
//
//     int iDayOfWeek      //---- INTEGER DAY OF WEEK             - THE DAY OF WEEK TO USE FOR THE CALCULATIONS | FILTER OPTION - CAN BE ANY VALUE BETWEEN 0 - 6
//                                                                         SUNDAY: 0
//                                                                         MONDAY: 1
//                                                                        TUESDAY: 2
//                                                                      WEDNESDAY: 3
//                                                                       THURSDAY: 4
//                                                                         FRIDAY: 5
//                                                                       SATURDAY: 6   
//
//                                                                   IE: IF THE INPUT IS TUESDAY WE WOULD CALCULATE AN AVERAGE OF THE LAST 26 TUESDAY'S RANGES.         
//
//     int iSession        //---- INTEGER SESSION                 - THE SESSION TIMES TO USE FOR THE CALCULATIONS | FILTER OPTION - CAN BE ANY VALUE BETWEEN 0 AND 4
//                                                                  SEE ABOVE "SESSION MODES CODE DEFINES" 
//                     
//  string sSessionStart   //---- STRING SESSION START TIME       - THIS STRING MUST BE IN THE FOLLOWING FORMAT "13:00" - ALSO NOTE THE USE OF 24H BASED TIME
//                                                                  SESSION START AND END TIMES DEFINES  
//
//  string sSessionEnd     //---- STRING SESSION END TIME         - SAME AS ABOVE 
//                                                                  SESSION START AND END TIMES DEFINES
//
//      DESCRIPTION:
// ----------------- 
//  
//
//+-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+ 