//+------------------------------------------------------------------+
//|                                    IBFX - Quick SL-TP Modify.mq4 |
//|                               Copyright 2010, Interbank FX, LLC. |
//|                                              http://www.ibfx.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Interbank FX, LLC."
#property link      "http://www.ibfx.com"
#property show_inputs
/*+------------------------------------------------------------------+
Because these scripts are meant to execute fast there are no user 
external inputs. Make sure to modify the settings below, then compile 
the script before assigning a hot key to it and using it.
Do not forget to click on COMPILE once your changes have been made!!!
+------------------------------------------------------------------+*/

extern int   MagicNumber = 0;  // Magic Number
extern int      StopLoss = 50; // Number in Pips ie: 50 for 50 pips.
extern int  ProfitTarget = 50; // Number in Pips ie: 50 for 50 pips.

//+------------------------------------------------------------------+
//|                  DO NOT MODIFY ANYTHING BELOW                    |
//+------------------------------------------------------------------+
#include <IBFX - Quick Scripts.mqh>
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start()
{
   if( MagicNumber <= 0 ) { return; }
   
   //---- LOOP THRU LIVE ORDERS
   for( int i = OrdersTotal()-1; i >= 0; i-- )
   {
      //---- SELECT CURRENT ORDER
         
         //---- FILTERS
         if( !OrderSelect(i,SELECT_BY_POS,MODE_TRADES) ) { continue; } 
         if(  OrderMagicNumber() != MagicNumber ) { continue; } 
         
         //---- SET VARS
         string       Sym = OrderSymbol();
         double SymPoints = MarketInfo( Sym, MODE_POINT  );
         double SymDigits = MarketInfo( Sym, MODE_DIGITS );
      
              if( SymPoints == 0.001   ) { SymPoints = 0.01;   SymDigits = 3; }
         else if( SymPoints == 0.00001 ) { SymPoints = 0.0001; SymDigits = 5; }
      
         int OT = OrderType();
         
              int thisTN = OrderTicket();
           double thisOP = NormalizeDouble( OrderOpenPrice(),  SymDigits );
         datetime thisOE = OrderExpiration();
           double thisTP = NormalizeDouble( OrderTakeProfit(), SymDigits );
           double thisSL = NormalizeDouble( OrderStopLoss(),   SymDigits );
         
         double NEWSLLVL = 0.0; // NEW STOP LONG LEVEL
         double NEWSSLVL = 0.0; // NEW STOP SHRT LEVEL
         double NEWTLLVL = 0.0; // NEW TAKE LONG LEVEL
         double NEWTSLVL = 0.0; // NEW TAKE SHRT LEVEL
         
         //---- SWITCH
         switch( OT )
         {
            case       OP_BUY:
            case  OP_BUYLIMIT: NEWTLLVL = NormalizeDouble( TakeLong( OrderOpenPrice(), ProfitTarget, SymPoints, SymDigits ), SymDigits );
                               NEWSLLVL = NormalizeDouble( StopLong( OrderOpenPrice(),     StopLoss, SymPoints, SymDigits ), SymDigits );
                              
                               if( thisTP !=  NEWTLLVL || thisSL !=  NEWSLLVL )
                               { OrderModify( thisTN , thisOP, NEWSLLVL, NEWTLLVL, thisOE, CLR_NONE ); }
                               //----
                               break;
                               //----
            case      OP_SELL: 
            case OP_SELLLIMIT: NEWTSLVL = NormalizeDouble( TakeShrt( OrderOpenPrice(), ProfitTarget, SymPoints, SymDigits ), SymDigits ) ;
                               NEWSSLVL = NormalizeDouble( StopShrt( OrderOpenPrice(),     StopLoss, SymPoints, SymDigits ), SymDigits ) ;
                               
                               if( thisTP !=  NEWTSLVL || thisSL !=  NEWSSLVL )
                               { OrderModify( thisTN, thisOP, NEWSSLVL, NEWTSLVL, thisOE, CLR_NONE ); }
                               //----
                               break;
                               
                               //----
                      default: break;
         }
         //----
   }
   //----
   return;
}
//+------------------------------------------------------------------+